NOTE: 	the number [#???] stands for the build-counter shown at the
	beginning, if starting with  uip.exe -w

DEVELOPMENT-LOG (Reversed order...):
09.05.97	----> 2.3 [#869]
		-improved UPV-Fileformat #3 (versions below 2.3 can't read them!)
		-improved text-kinds
08.05.97	-packing volumes
		-some hotkeys for  editor (alt-n,F5,F6,F2,F3,INS,DEL)
		-first 160-patches version of gamebase-volume
05.05.97	-finally finished load/save-browser for all editor-things
		-fixed "LoadSettingsDoesNotUpdateLogo"-bug
		-adjusted some text-positions complained by sentinel
		-adjusted right button-help for sort volumes
26.05.97	-fixed "AskButtonsMayBeTooBig"-bug
		-fixed "FalsePatchKindsDisplayedInUsePatchWindow"-bug
20.04.97 15.30	----> 2.24 [#653]
		-page up/down in text-editor
		-fixed "ESCInTexteditorWillSetStrangeFont"-bug
		-finished load browser (for solution, text, info)
19.04.97	-fixed Search-Offset flag-displaying
		-fixed "DeletingLinkedOptionsMayCrashSystem"-bug
18.04.97 12:00	----> 2.23 [#515] (computer-club-fixes...)
		-adjusted DebugModeMousePointer-Setting
		-adjusted Scrollbar-handling (clicking outside button...)
		-n = sort for name in mainmenu
		-fixed "AddVolumeMakesStrangeThings"-error
		-adjusted Include-Window
		-adjusted "Solution/Hint/Help"-TextQuitting
		-Fixed "StrangeDisplayOfEmptyTexts"-bug
		-CheckVol,EditInfo/name not possible if volume locked
		-fixed button of user-definition in UsePatch
		-added "UnNamed" as name for newly added patch
		-fixed minor-bug in Ask-Box-Function
		-readded ã-Button into Config-Page
		-Space has same effect as Enter in Ask-Boxes
		-See Selected volume after resorting/adding volumes
16.04.97 12:00	-fixed "EmptyListScrollbarsCrashSystem"-bug
13.04.97 12:00	-fixed "EditInfoScrollbarCrashsSystem"-bug
		-adjusted EditInfo screen update
13.04.97 12:55--------> 2.22 [#423]  (first complete internet-release)
		-fixed "EnteringHexFileposFailed"-bug
		-fixed "UseCompareBytesIgnored"-bug
		-adjusted config-layout [syntech..]
		-fixed major-bug in usepatches
		-added some texts to use-textonly patches
		-added volume-name to use-patches
		-added debug-mouse-pointer
09.04.97 23:00:	----------> 2.21 [#381] (aitor)
		-found bug in patch-function (not fixed yet...)
		-fixed some strange state-names to on/off changed/original
		-reversed changed/original
		-fixed "DeletingLastOptionNotDisplayed"-bug [#370]
08.04.97 11:07: ----------> 2.20 [#361]
		-fixed "Scroll"-bug
		-fixed "OptionScrollbarNotSelectable"-bug
		-fixed "TextInHighlightedButtonsTooLong"-bug
08.04.97 01:21	-some new greets
		-cool scrollbar-grapping desired by nonex
		-fixed "StrangeColoredTextScrolling"-bug
05.04.97 12:00	-use text/include-patch
		-partly fixed "StrangeScrollColoredText"-bug
		-fixed major bug, when looking at patches with 0 options
		-adjusted "know-bugs"-text
		-adjusted "greetings"-text
		-fixed some english-errors withing the help-texts
04.04.97 12:00	------> v2.19 [#288] (released at internet)
		-fixed "StrangeUsePatchScreenAfterHelp"-bug
		-added SearchPatches/FoundPatches-Windows into main-screen
03.04.97 24:00	-fixed "StrangeTexteditorMousePositioning"-bug
		-fixed "NotEnterTerminatedLineNotShown"-bug
03.04.97 23:00	--------> v2.18 [#251] (released at computer-club ,pear,mario,franze)
		-fixed "FuckingColorConversion"-Bug
		-fixed "NoUpdatedFlagsDisplay"-bug
		-fixed "UnableToSortForKind"-bug
		-added "FixStrangeColorConversions"-function
01.04.97 16:19	--------> v2.17 [#232]
		-fixed "GreenFilelistEnd"-bug
		-added "use numbers"
		-if numbers, pattern may be edited as numbers
		-fixed some minor-bugs in EditorLayout
		-fixed # in Mini-Font
		-adjusted PatchKind in Mainmenu and Editor
		-adjusted Help of Sort Patches/Volumes
		-fixed "HelpOnlyOnce"-bug
		-included FTP-Sites and Homepage into Known Bugs - Help
		-Autosort-Option
31.03.97 01:23:	-fixed CrashOnMostSystem-bug
		-----------> 2.15
		-patching should now work with all option-kinds
		-fixed lot of bugs in PatchUser
30.03.97 17:49:	-added help-screen
		-added known bugs toppic
		-added char-dump for compare dump
		-fixed some errors within ulpCheckActFile
		-uppSaveChanges()
		-some more upp-Function like on/off
26.03.97 15:46:	-SavingChanges() works for Absolute offset - options
		-BakfileOptions checked, Bak-file copy-function is still missing
		-fixed minor-bug in LName2FName()
		-fixed major bug: when patch-number decreased after changing vol-path->
		 system crashed!
26.03.97 14:57:	-started SaveChanges()
		-added all RightButtonHelpTexts from editor into text.ctx
		-fixed minor-bug in ScanFiles()
		-continued UsePatches() ...
		-added CreateBakFile/NeverOverwriteBakFile-Options into Config-page
25.03.97 21:14:	-EditVolInfo()
		-fixed major bug in LoadVolx (wondered how it ever worked like this...)
		-fixed "UnwantedFontSelection"-bug in Config-Page
		-fixed some minor-bug within TextEditing (like change-Flags not increased)
		-ScrollbarAdjust()
		-fixed majorbug, crashing system, after deleting Patches and going back
		 to MainMenu
		-RightMouse Button always keeps Text after editing
		-fixed "UnableToUseRootDirectory"-bug (detected as c:\\ instead of c:\)
		-fixed minor bug in Patch/OptionSelectScrollbarUsage
		-SGI2-Buttons are now default
		-scrollbars have now the exact color of the Buttons
		-nice ChangeButton within Editor
		-fixed "StrangeTextInGetSizesAndCmpDump-Window"-bug
24.03.97 12:31:	------->v2.14
		-fixed unknow directory-bug in ulp
		-added various sort-file-methods
		-fixed some minor-bugs in ulp
		-put most texts and strings from ulp in to text.ctx
		-included 2nd old-fashioned logo
23.03.97 19:30: -------->v2.13
		-fixed lots of errors in editor
		-finally adjusted search,replace-offsetkinds
		-added option will have offsetkind of parent
		-fixed major-bug in the text-editor
		-"ESC will abandon text"-flag
		-PrintMono()
		-text-editor available for normal patches
17.02.97 19:00: -fixed small bug in right button-help
13.02.97 01:00:	-fixed "del-patch-deletes-vol-bug"
12.02.97 00:01	-included mono-spaced font into config and cfg-file
		-included mono-spaced-font into DrawText()
		-fixed some bugs in etXXX
		-et-functions (complete Texteditor)
		-10-change-button not only in debug-mode
		-60-new choose-button like SGI (choose from list) for drive in ulp
		-20-when printing the name of buttons, length button should be included
20.01.97 12:23: --------> 2.12  (note, UPV-format incompatible to 2.11!)
		-patchkinds SOLUTION & SAVEGAME (desired by BOSS)
		-fixed some minor bugs in editor and main
		-cool scrolling for patch-list in editor
		-next/prev-patch with PAGE DOWN/UP in editor
		-edit volume-text (window, only)
		-use3f-buttons (buttons, only)
20.01.97 03:35:	-no more flickering in editor [40']
		-new mainmenu [name,author/volume,kind (+numoption) (date) (found)
		-repl: "Search","Replace" for datefields
		-set color-filter of PatchName/VolumeName in editor [20']
		-SortPatches [40']
		-edit text in trainer and patch  missing [50']
13.01.97 09:30: --------> 2.11
		x20-SortVolumes
		x20-Fixed bug in save/load-functions
		x30-Fixed some minor bugs in editors
		x20-volumeliste nicht vollst„ndig [both dates, number of options, locked]
		x20-when leaving editor to ulp, use the editor's patch
		x30-savegame-window for trainers [len,pos,flag]
		x80-rightbutton-help
05.01.97 23:32:	-------->2.10
		-finally complete new LoadVolX()
		-MakePList and MakeVList together in MakeVPList() useing LoadVolX
		-checksum works fine
		-reasonably errorhandly in LoadVolX()/MakeVPList()
05.01.97 19:06:	-"select patch by ..." in mainmenu
		-"check volumes" should give out message, even if no errors has been found
		-"check..." should be called check volume
		-absolute: "1st/2nd"->"Changed","Org"
		-after setting default-values not the correct logo
		-all buttonnames in CAPITALS [test search,2nd from file]
		-correct button-names [SGI,UGLY,FT2,SGI/FT2]
		-esc geht in config nicht
		-give newly added patch a name (unnamed...)
		-in mainmenu patchname could be longer
		-in mainmenu should be 4 pixels high line between logo and menu-editor still there
		-information: 1 volumeS
		-range-values in replace-option are 2 too long
		-repl: "one way patch-> "one way"
		-repl: when entering replace, mouse off!
		-when changing the dez-offset-position, spaces before number
		-eosOffset
		-eosHexDez
		-entering hex-offset gives false values
		-check patch should give a message or missing
		-check, if no text in editor
		-correct color-shemes-names in config [paladin,straight,braun,blaun,rose,dark rose,lcd,jungle,mud,lego,?,voilent rose,dasa,fire,blues]
		-in config volumestring is added by '\'
		-keep mouse-positions doesn't work in mainmenu
		-repl: check,if rangevalues are valid
		-repl: when clicking of 2nd range-value, first one edited
		-show number of patches if trainer or patch
		-when making a patch one-way, the cmp-option is reset, but the screen not updated
		-when running editor, not the correct patch shown
		-only make to previous, if original has same offsetkind
		-save changes when exit
		-config-page.password
		-error with unselectable button / better hide in ulp
		-offsetkind of option in option-list
		-locking patch should work
??.01.97 ??:??:	-changes not increased, if changing pkind
		-usefile-name not corectly edited
		-max/min-sizes without any 0
		-include-window without text-window like hint/keycode
		-include-filename edit 8 to long print 1 hoch,edit 1runte
		-print 8 too long 1zu tief
		-keycode-patchname edit 8zulang,1nach rechts
		-update patchlist
		-identfilename edit 3 toolong
		-trainername-edit 1 rechts
		-update patchlist
		-enter loest exemption aus
		-create/modif-time of volumes is missing in vol-list (editor)
		-max/min-size linksbuendig
		-when changing size, change-counter+02
		-nach edit OptionName, update esoPrintInfo()
		-Punkt als neu-optioname ist schlecht
		-filepos bei dez linksbuendig
		-2nd by Absolute is bei edit v”llig falsch
		-1st/2nd bei search wird nicht richtig ausgegeben / kann nicht editiert werden
		-die einzelnen offset-typen muessen checken, ob ein to-prev. zu einem
		-wenn 1-way-patch be filesize, trotzdem 2nd editierbar
		-bei absolut auch
		-between range bei replace-edit ist voelling falsch, linkbuendig, ohne 0, da dez
		-between range-flag much changes++
		-enable auch
		-multi auch
		-1st/2nd bei replace changes++
		-editname bei replace ist immer von der ersten option
		-after AddVolume, the PatchList is not build up
		-max/min-size still not left-formatted
		-crypted-flag seems the be set at will, why?
		-offsetkind-toprev-check must be rewritten
		-after leaving config, Info in main not shown
		-date in mainlist
		-mouse-pos at ChooseButton should have other color
		-cmp/size-check always off, when loading OLD-patches
		-ask to save, if leaving editor
31.12.96 22:06:	-fixed strange edit-option-name-error
10.12.96 06:58:	-fonts-selection via ø1-5ø
		-preformated font for dir-lists
		-nearly finished file-selection-box in ulp
		-fixed small bug in DrawText()
		-Text shown in ulp
08.12.96 06:31:	----> v2.07
		-reformated some parts of hiwin.c
		-fixed no logo-bug (83<16 instead of 83<<16)
		-fixed some minor bugs in hiwin.c
		-added file-list to ulp
		-fixed "false filepos stored in e"-bug
		-added optionlist to ulp
		-fixed some other bugs in ulp
11.11.96 12:01: ----> v2.06
		-added UNP's make-file
28.10.96 12:35:	-edittext almost ready (Entf,page up/down missing)
		-DrawText
		-fixed small bug in Print (enter not same as 0)
28.10.96 10:26: -fixed small bug in DEL-Patch (unable to reload vol, after saved)
		-started EditText()
		-GetPos();
13.10.96 11:53	---------> 2.05
		-EditLine kommt nicht mit rechts-scrollen zurecht
		-cmp-header koennte man ruhig mit ausgeben
		-OffsetKind koennte noch in option-liste (wie bei patchliste)
		-PrintDate should leave the first 4 pixels empty
		-SortPatches
		-SortVolumes
		-all things connected with Replace
		-change-button not only in debug-mode
		-check if right colors, when entering patch-name
		-create/modif-time of patches is missing in main-list
		-editing offset in dez-crashs system
		-es kommt immer nur ein logo, egal, was in config
		-green bar in option-list should reach right border
		-header of volume-list to distinguish creat/modif-time
		-logo not loaded in main, immediately after entering
		-number of patches and filesize in volume-list
		-numbers ist bei 1st/2nd (absolute) nicht abgefragt
		-reset to original color with Xx
		-savegame-name-window, if on
		-search-pattern kann noch nicht editiert werden
		-sort-parameter in cfg-file
		-the green bar in the volume-list should reach the right border
		-use-toprev-searchbutten bei Search wird nicht richtig abgefragt
		-1st/2nd bei replace changes++
		-1st/2nd bei search wird nicht richtig ausgegeben / kann nicht editiert werden
		-2nd by Absolute is bei edit v”llig falsch
		-Punkt als neu-optioname ist schlecht
		-after AddVolume, the PatchList is not build up
		-after leaving config, Info in main not shown
		-ask to save, if leaving editor
		-bei absolut auch
		-between range bei replace-edit ist voelling falsch, linkbuendig, ohne 0, da dez
		-between range-flag much changes++
		-changes not increased, if changing pkind
		-cmp/size-check always off, when loading OLD-patches
		-create/modif-time of volumes is missing in vol-list (editor)
		-crypted-flag seems the be set at will, why?
		-date in mainlist
		-die einzelnen offset-typen muessen checken, ob ein to-prev. zu einem
		-editname bei replace ist immer von der ersten option
		-enable auch
		-enter loest exemption aus
		-filepos bei dez linksbuendig
		-identfilename edit 3 toolong
		-include-filename edit 8 to long print 1 hoch,edit 1runte
		-include-window without text-window like hint/keycode
		-keycode-patchname edit 8zulang,1nach rechts
		-max/min-size linksbuendig
		-max/min-size still not left-formatted
		-max/min-sizes without any 0
		-mouse-pos at ChooseButton should have other color
		-multi auch
		-nach edit OptionName, update esoPrintInfo()
		-offsetkind-toprev-check must be rewritten
		-print 8 too long 1zu tief
		-trainername-edit 1 rechts
		-update patchlist
		-update patchlist
		-usefile-name not corectly edited
		-wenn 1-way-patch be filesize, trotzdem 2nd editierbar
		-when changing size, change-counter+02
13.10.96 01:45: ----->v2.04
		-lots of minor-changes in the edit-page
12.10.96 23:19:	-included logo
		-fixed minor-bug in set-patch
		-fixed "AskKeepTooSmallWindowBug"
12.10.96 22:41:	-Add/DelPatch/Option
		-ChangeButton
		-change-counter
		-some more edit-features
12.10.96 17:21:	-EditBytePattern()
		-search/replace-pattern editable
12.10.96 14:50:	-fixed "NotAllPushedBug"-in GetWidth
		-some exit-slogans into mainmenu
12.10.96 14:20:	-adjusted pos of max/min-edit
		-adjusted text of size-warnings
		-funky exit-notes
		-adjusted Button/header-text-alignment in Ask-Boxes
10.10.96 14:17:	------> v2.03
		-tried a little bit with TAB/Jumps in Print
		 ->not neccassary and goddamn difficult
		-modif-times for Volumes/Patches
		-small font
		-PrintProp deleted
		-ChangePatchDate()
		-some time-functions
		-modif-date in SaveVolX
		-fixed "IncompleteUsefileWhenOldUPV-Format"-bug
10.10.96 11:25: -fixed small bug in Print
		-fixed small bug (after 4h search) in NEditLine
		-hide option, if none exists
		-show patch-type in patch-list
		-added some "changes"
08.10.96 23:47:	-finally detected some bugs in Print-Functions
		-EditLine-function works
		-GetWidth without format-pattern-special treatment
		-config-volume-dir adjusted
		-edit Volume-Name/Author
07.10.96 12:56:	-------> v2.02
		-loading and saving volumes seems to work completely fine
		-a volume_error-flag, that prevents from exeption-quit
		 up2, but just doesn't show anything of the (not) loaded volume
		-Up/DownBarFunct
		-old_format-bit into volume-structure
		-select-volume
		-volumelist up/down
06.10.96 22:55:	-adjusted/commented most of the Global Vars in up.c
		-"cool" scrollbar in maine.c
		-fixed minor bug in MakePList()
06.10.96 22:19:	-ident-file into patch-struct (not used yet)
06.10.96 22:01:	-warning-level4 with compiler and fixed some like unused vars
		-working version of MakePList()
		-added kind,dates to patche-structure
		-fixed some bugs at ReplaceString
		-ChkFree()
		-check MakePList()
		-BuildInfos in Editor
		-LoadPatch()
		-SavePatch()
		-ChooseOffsetKind()
		-text-window
		-black-areas
18.09.96 08:23: -fixed some bugs at ChooseButton();
		-choosing patch-kind-works
18.09.96 08:09: -added first switching through patch-kinds
18.09.96 02:22:	------> v2.00
   		-finished nearly all edit-screen-definitions
   		-ChooseButtonWin()
	   	-ChooseButton() completely rewritten
		-maine() completely rewritten
		-Print() - asm-function, added (all new functions are using
		 this one... older Print-functions should be replaced
		-added 2nd Proportional font
		-added first preview-pals
		-config-screen nearly ready (completely new...)
		-added window-structure (for multiple window-screens)
		-added advanced hotkey-usaged into ChooseButton[Win]
		-added version-check for up.cfg
		-added new pal (adjusted all buttons, desktops...)
		-added new area-color-definitions


Think about:
-autodetect patches
-GetWidth,GetPos with actual font
-choosed-button for drives in Ulp
-crypting
-reset to original color with Xx
-keep and restore old text-mode
-GetPos / GetWidth into GetPosX/GetWidthX for including special chars.
-esc bei edit-line hinterl„át cursor
-for final release these option are essential:
	-load/save of text / for all text-editors
	-some helps into Ulp() or complete
-for final release 2:
	-patch-browser
	-split text-editor
	-save-function in text-Ulp
	-autodetect-function
	-scan-function
	-search/save list of patches

